Option Strict On

Imports System.Drawing
Imports System.Drawing.Drawing2D
Imports System.Drawing.Text

Public Class Form1
    Inherits System.Windows.Forms.Form
    ' references u1432class.dll 
    ' in turn this calls use1432.dll and this .dll must be in the system root
    ' Options include channel and command directory.
    ' the data display was the most work
    ' originally had a picturebox element but there is a 
    ' bug in VB.NET 1.1 in painting it, so changed this to 
    ' a drawing rectangle
    Private my1432class As New U1432class.DeclareFn
    Private is1401Open As Boolean = False ' initialise
    Private handle14 As Int16
    Private chanToDo As String ' can select channel to record
    Private palNum(10) As Int32
    Private Const datal As Integer = 1000 ' 1 sec at 1 kHz
    Private data1401(datal) As Int16 ' one spare,only need 1000
    Private haveKilled As Boolean = False
    Private retString As String = New String(CChar("0"), 50) ' intialise
    ' graphics related
    Private gr As Graphics
    Private pa, pAxis As New GraphicsPath
    Private scaleX As Single = 1
    Private scaleY As Single = 1
    Private pBlack As New Pen(Color.Black, 1)
    Private pRed As New Pen(Color.Red, 1)
    Private haveDrawn As Boolean = False
    Private offset As Integer = 32768
    Private aFont As New Font("Arial", 10)
    Private br As New SolidBrush(Color.Black)
    Private drawRect As Rectangle
    Private topL As Point


#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        Timer1.Enabled = False
        Timer1.Interval = 50 ' 50 ms polling interval
        Label1.Text = "" ' positive feedback
        ckTrigger.Checked = False
    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents MainMenu1 As System.Windows.Forms.MainMenu
    Friend WithEvents MenuItem2 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem3 As System.Windows.Forms.MenuItem
    Friend WithEvents Timer1 As System.Windows.Forms.Timer
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents MenuItem1 As System.Windows.Forms.MenuItem
    Friend WithEvents adcmem As System.Windows.Forms.MenuItem
    Friend WithEvents bailout As System.Windows.Forms.MenuItem
    Friend WithEvents quit As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem4 As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem5 As System.Windows.Forms.MenuItem
    Friend WithEvents txtBoxChanNo As System.Windows.Forms.TextBox
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents Label4 As System.Windows.Forms.Label
    Friend WithEvents TextBox2 As System.Windows.Forms.TextBox
    Friend WithEvents TextBox1 As System.Windows.Forms.TextBox
    Friend WithEvents Label5 As System.Windows.Forms.Label
    Friend WithEvents ckTrigger As System.Windows.Forms.CheckBox
    Friend WithEvents MenuItem6 As System.Windows.Forms.MenuItem

    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.Timer1 = New System.Windows.Forms.Timer(Me.components)
        Me.Label1 = New System.Windows.Forms.Label
        Me.MainMenu1 = New System.Windows.Forms.MainMenu
        Me.MenuItem1 = New System.Windows.Forms.MenuItem
        Me.adcmem = New System.Windows.Forms.MenuItem
        Me.bailout = New System.Windows.Forms.MenuItem
        Me.quit = New System.Windows.Forms.MenuItem
        Me.MenuItem4 = New System.Windows.Forms.MenuItem
        Me.MenuItem5 = New System.Windows.Forms.MenuItem
        Me.MenuItem6 = New System.Windows.Forms.MenuItem
        Me.TextBox2 = New System.Windows.Forms.TextBox
        Me.txtBoxChanNo = New System.Windows.Forms.TextBox
        Me.Label3 = New System.Windows.Forms.Label
        Me.Label4 = New System.Windows.Forms.Label
        Me.TextBox1 = New System.Windows.Forms.TextBox
        Me.Label5 = New System.Windows.Forms.Label
        Me.ckTrigger = New System.Windows.Forms.CheckBox
        Me.SuspendLayout()
        '
        'Timer1
        '
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(48, 56)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(384, 32)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "Label1"
        '
        'MainMenu1
        '
        Me.MainMenu1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItem1, Me.MenuItem4})
        '
        'MenuItem1
        '
        Me.MenuItem1.Index = 0
        Me.MenuItem1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.adcmem, Me.bailout, Me.quit})
        Me.MenuItem1.Text = "Sample"
        '
        'adcmem
        '
        Me.adcmem.Index = 0
        Me.adcmem.Text = "ADCMEM"
        '
        'bailout
        '
        Me.bailout.Index = 1
        Me.bailout.Text = "Halt Task"
        '
        'quit
        '
        Me.quit.Index = 2
        Me.quit.Text = "Quit"
        '
        'MenuItem4
        '
        Me.MenuItem4.Index = 1
        Me.MenuItem4.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItem5, Me.MenuItem6})
        Me.MenuItem4.Text = "About"
        '
        'MenuItem5
        '
        Me.MenuItem5.Index = 0
        Me.MenuItem5.Text = "1401"
        '
        'MenuItem6
        '
        Me.MenuItem6.Index = 1
        Me.MenuItem6.Text = "Code"
        '
        'TextBox2
        '
        Me.TextBox2.Location = New System.Drawing.Point(376, 16)
        Me.TextBox2.Name = "TextBox2"
        Me.TextBox2.Size = New System.Drawing.Size(32, 20)
        Me.TextBox2.TabIndex = 2
        Me.TextBox2.Text = "0"
        '
        'txtBoxChanNo
        '
        Me.txtBoxChanNo.Location = New System.Drawing.Point(512, 16)
        Me.txtBoxChanNo.Name = "txtBoxChanNo"
        Me.txtBoxChanNo.Size = New System.Drawing.Size(32, 20)
        Me.txtBoxChanNo.TabIndex = 3
        Me.txtBoxChanNo.Text = "0"
        '
        'Label3
        '
        Me.Label3.Location = New System.Drawing.Point(424, 16)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(72, 24)
        Me.Label3.TabIndex = 4
        Me.Label3.Text = "Channel no."
        Me.Label3.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Label4
        '
        Me.Label4.Location = New System.Drawing.Point(312, 16)
        Me.Label4.Name = "Label4"
        Me.Label4.Size = New System.Drawing.Size(56, 16)
        Me.Label4.TabIndex = 5
        Me.Label4.Text = "1401 No:"
        Me.Label4.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'TextBox1
        '
        Me.TextBox1.Location = New System.Drawing.Point(136, 16)
        Me.TextBox1.Name = "TextBox1"
        Me.TextBox1.Size = New System.Drawing.Size(144, 20)
        Me.TextBox1.TabIndex = 6
        Me.TextBox1.Text = "C:\1401\"
        '
        'Label5
        '
        Me.Label5.ImageAlign = System.Drawing.ContentAlignment.MiddleRight
        Me.Label5.Location = New System.Drawing.Point(8, 16)
        Me.Label5.Name = "Label5"
        Me.Label5.Size = New System.Drawing.Size(112, 24)
        Me.Label5.TabIndex = 7
        Me.Label5.Text = "Command directory:"
        '
        'ckTrigger
        '
        Me.ckTrigger.Location = New System.Drawing.Point(576, 16)
        Me.ckTrigger.Name = "ckTrigger"
        Me.ckTrigger.Size = New System.Drawing.Size(184, 24)
        Me.ckTrigger.TabIndex = 8
        Me.ckTrigger.Text = "Wait for trigger pulse"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(856, 614)
        Me.Controls.Add(Me.ckTrigger)
        Me.Controls.Add(Me.Label5)
        Me.Controls.Add(Me.TextBox1)
        Me.Controls.Add(Me.txtBoxChanNo)
        Me.Controls.Add(Me.TextBox2)
        Me.Controls.Add(Me.Label4)
        Me.Controls.Add(Me.Label3)
        Me.Controls.Add(Me.Label1)
        Me.Menu = Me.MainMenu1
        Me.Name = "Form1"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub quit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles quit.Click
        ' there might be a problem if the user doesn't click Exit
        Timer1.Enabled = False
        If is1401Open Then
            my1432class.U14Reset1401(handle14)
            my1432class.U14Close1401(handle14)
        End If
        br.Dispose()
        aFont.Dispose()
        pBlack.Dispose()
        pRed.Dispose()
        pa.Dispose()
        gr.ResetTransform() ' for completeness
        gr.Dispose()
        Me.Close()
    End Sub

    Private Sub adcmem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles adcmem.Click
        Dim res As Int16
        Dim lres As Int32
        Dim trigText As String
        trigText = ""
        haveKilled = False
        chanToDo = txtBoxChanNo.Text
        If Not is1401Open Then
            handle14 = my1432class.U14Open1401(CShort(TextBox2.Text)) ' user can specify
        End If
        If handle14 < 0 Then
            is1401Open = False
            MessageBox.Show("Can't open 1401: error returned is: " + my1432class.DecipherErr16(handle14))
        Else ' can assume open now
            is1401Open = True
            Label1.Text = "1401 opened"
            my1432class.U14Reset1401(handle14)
            lres = my1432class.U14Ld(handle14, TextBox1.Text, "ADCMEM") ' returns a long (integer)
            If lres <> my1432class.U14ERR_NOERROR32 Then
                MessageBox.Show("Problem with loading commands, lres returns: " + lres.ToString)
            Else ' commands loaded OK
                ' note the use of the terminal ERR here as it sets up for LongsFrom1401
                ' collect 1000 int16 points at 1 kHz (1 Mhz div 4 div 250) on specified channel
                If Not ckTrigger.Checked Then
                    my1432class.U14SendString(handle14, "ADCMEM,I,2,0,2000," + chanToDo + ",1,C,4,250;ERR;")
                Else
                    my1432class.U14SendString(handle14, "ADCMEM,I,2,0,2000," + chanToDo + ",1,CT,4,250;ERR;")
                    trigText = ": awaiting trigger"
                End If
                lres = my1432class.U14LongsFrom1401(handle14, palNum(0), 2)
                If lres <> 2 Then
                    MessageBox.Show("Error with loading ADCMEM command, U14Longs returns: " + lres.ToString)
                Else
                    Label1.Text = "1401 open, cmds loaded into1401, timer started" + trigText
                    Timer1.Enabled = True
                End If
            End If
        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim val As Int16
        Dim i As Integer
        Dim midX As Int16
        Dim XaxInc As Int16 = 2500
        Dim YaxInc As Int16 = 10
        If Not haveKilled Then
            my1432class.U14SendString(handle14, "ADCMEM,?;")
            my1432class.U14GetString(handle14, retString, 50)
            val = CShort(retString)
            If val = 0 Then  ' have collected a sweep
                Timer1.Enabled = False
                Label1.Text = "Data collected - will display"
                val = my1432class.U14ToHost(handle14, data1401(0), CInt(datal * 2), 0, 0)
                If val <> my1432class.U14ERR_NOERROR Then
                    MessageBox.Show("Error with ToHost, returns: " + val.ToString + ": " + my1432class.DecipherErr16(val))
                Else
                    ' now draw the data
                    scaleY = 1
                    gr.Clear(Form1.ActiveForm.BackColor)
                    drawRect.Width = ActiveForm.ClientSize.Width
                    drawRect.Height = ActiveForm.ClientSize.Height - drawRect.Location.Y - 20
                    pa.Reset() ' clear out any previous datapoints
                    pAxis.Reset()
                    gr.ResetTransform()
                    ' note scaling affects DrawString
                    gr.DrawString("Data collected: chan " + chanToDo + ", " + datal.ToString + " points", aFont, br, 10, 100)
                    ' Label1.Text = "3 pts of data: " + data1401(0).ToString + "; " + data1401(1).ToString + "; " + data1401(2).ToString
                    offset = 32768 ' ensures plot centered
                    scaleX = Convert.ToSingle(drawRect.Width / (datal + 1))
                    scaleY = Convert.ToSingle(drawRect.Height / (2 * offset))
                    gr.TranslateTransform(0, Convert.ToSingle(drawRect.Height / 2) + drawRect.Location.Y) ' move origin to middle of picture
                    gr.ScaleTransform(scaleX, scaleY)
                    pa.StartFigure()
                    For i = 0 To datal - 2
                        pa.AddLine(i, 0 - data1401(i), i + 1, 0 - data1401(i + 1)) ' a crude way to invert the figure
                    Next
                    pa.StartFigure() ' stop connecting the two segments 
                    pa.CloseFigure()
                    ' now draw simple axes
                    pAxis.StartFigure()
                    pAxis.AddLine(YaxInc, offset, 0, offset)
                    pAxis.AddLine(0, offset, 0, -offset) ' yaxis, mark top and bottom
                    pAxis.AddLine(0, -offset, YaxInc, -offset)
                    pAxis.StartFigure()
                    midX = Convert.ToInt16(datal / 2)
                    pAxis.AddLine(0, 0, midX, 0) ' x axis (1/2 way)
                    pAxis.AddLine(midX, 0, midX, -XaxInc)
                    pAxis.StartFigure()
                    pAxis.AddLine(midX, 0, datal, 0)
                    pAxis.AddLine(datal, 0, datal, -XaxInc)
                    pAxis.StartFigure()
                    pAxis.CloseFigure()
                    gr.DrawPath(pBlack, pa)
                    gr.DrawPath(pRed, pAxis)
                    haveDrawn = True
                    ' add some text
                End If  ' if val <> U14ERR_NOERROR
            End If ' if val = 0
        Else   ' user decided to kill the process
            Timer1.Enabled = False
            If is1401Open Then
                my1432class.U14Reset1401(handle14)
            End If
            Label1.Text = "Sampling halted"
        End If  ' if not haveKilled
    End Sub

    Private Sub bailout_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bailout.Click
        haveKilled = True
        adcmem.Enabled = False ' no more sampling
    End Sub

    Private Sub MenuItem5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem5.Click
        ' get details on the 1401 and driver
        Dim timeOut, baseAddr, memSize As Int32
        Dim state14, type14, ret As Int16
        Dim my1401type, my1401status, myText, myDriverType As String
        Dim buffer(20) As Byte ' to receive results
        Dim sendString As String
        Dim SNLow, SNHigh As String
        Dim TFlags As Integer
        Dim drVer, drType, monitorRev As Int32

        If Not is1401Open Then
            handle14 = my1432class.U14Open1401(CShort(TextBox2.Text))
            If handle14 < 0 Then
                myText = my1432class.DecipherErr16(handle14)
                MessageBox.Show(myText)
            Else
                is1401Open = True
            End If
        End If
        If is1401Open Then
            drVer = my1432class.U14DriverVersion
            drType = my1432class.U14DriverType
            monitorRev = my1432class.U14MonitorRev(handle14)
            Select Case (drType)
                Case 0
                    myDriverType = "Windows with ISA card"
                Case 1
                    myDriverType = "Windows with PCI card"
                Case 2
                    myDriverType = "Windows with USB interface"
                Case Else
                    myDriverType = "Unrecognised or unknown type"
            End Select
            TFlags = my1432class.U14TransferFlags(handle14)
            state14 = my1432class.U14Stat1401(handle14)
            Select Case (state14)
                Case my1432class.U14ERR_NOERROR
                    my1401status = "1401 OK"
                Case Else
                    my1401status = my1432class.DecipherErr16(state14)
            End Select
            type14 = my1432class.U14TypeOf1401(handle14)
            Select Case (type14)
                Case my1432class.U14TYPE1401
                    my1401type = "Std 1401"
                Case my1432class.U14TYPEPLUS
                    my1401type = "1401plus"
                Case my1432class.U14TYPEU1401
                    my1401type = "Micro1401(MkI)"
                Case my1432class.U14TYPEPOWER
                    my1401type = "Power 1401"
                Case my1432class.U14TYPEU1401MK2
                    my1401type = "Micro1401(MkII)"
                Case Else
                    my1401type = "Unrecognised or unknown type"
            End Select
            timeOut = my1432class.U14GetTimeOut(handle14)
            baseAddr = my1432class.U14BaseAddr1401(handle14)
            ret = my1432class.U14GetUserMemorySize(handle14, memSize)
            myText = ""
            myText = "Driver version: " + drVer.ToString + Chr(13) 'this needs a bit more work
            myText += "Driver type: " + myDriverType + Chr(13)
            myText += "Monitor version: " + monitorRev.ToString + Chr(13)
            ' now get serial number, use area 0
            ret = my1432class.U14SetTransArea(handle14, 0, buffer(0), 11, 0)
            If ret <> my1432class.U14ERR_NOERROR Then
                MessageBox.Show("Error with U14SetTransArea: " + my1432class.DecipherErr16(ret))
            End If
            sendString = "CONFIG,RH,0,11;ERR;"
            ret = my1432class.U14SendString(handle14, sendString)
            If ret <> my1432class.U14ERR_NOERROR Then
                MessageBox.Show("Error with Config command: " + my1432class.DecipherErr16(ret))
            Else
                ret = my1432class.U14LongsFrom1401(handle14, palNum(0), 2)
                If ret <> 2 Then
                    MessageBox.Show("Error with U14Longs")
                Else
                    SNLow = buffer(4).ToString
                    SNHigh = buffer(5).ToString
                    myText += "Serial No: " + SNHigh + ", " + SNLow + Chr(13)
                End If
            End If
            ret = my1432class.U14UnSetTransfer(handle14, 0)
            If ret <> my1432class.U14ERR_NOERROR Then
                MessageBox.Show("Error with U14UnSetTransArea: " + my1432class.DecipherErr16(ret))
            End If
            myText += "Transfer flags: " + TFlags.ToString + Chr(13)
            myText += "Status: " + my1401status + Chr(13)
            myText += "Type: " + my1401type + Chr(13)
            myText += "Base Addr: " + baseAddr.ToString + Chr(13)
            myText += "Memory: " + memSize.ToString
            MessageBox.Show(myText)
        End If

    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        ' called when form is resized, note: panel does not change size in this process
        Dim newHeight As Integer
        Dim midHeight As Single
        Dim newWidth As Integer
        If haveDrawn Then ' just rescale
            newHeight = ActiveForm.ClientSize.Height - drawRect.Location.Y - 20 '
            If newHeight > 10 Then
                drawRect.Height = newHeight
                midHeight = Convert.ToSingle(newHeight / 2)
                scaleY = Convert.ToSingle(newHeight / (2 * offset))
            End If ' if newHeight
            newWidth = ActiveForm.ClientSize.Width
            If newWidth > 100 Then ' if not, no change
                scaleX = Convert.ToSingle(newWidth / (datal + 1))
            End If
            gr.ResetTransform() ' clear the previous value
            gr.TranslateTransform(0, midHeight + drawRect.Location.Y) ' reset the zero level
            gr.ScaleTransform(scaleX, scaleY) ' and rescale
            gr.Clear(Form1.ActiveForm.BackColor)  ' have to redraw here or else no change when form is shrunk
            gr.DrawPath(pBlack, pa)
            gr.DrawPath(pRed, pAxis) ' and Axes
        End If ' haveDrawn
    End Sub

    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
        ' called if form obscured and then revealed or if form enlarged (only), not when reduced
        If haveDrawn Then ' redraw if there is a path
            ' gr.Clear(Form1.ActiveForm.BackColor)
            gr.DrawPath(pBlack, pa)
            gr.DrawPath(pRed, pAxis) ' and Axes
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        gr = Me.CreateGraphics
        topL.X = 0 ' top left location for drawRect
        topL.Y = 120
        drawRect.Location = topL
    End Sub

    Private Sub MenuItem6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem6.Click
        MessageBox.Show("Simple 1401 application in VB.NET 1.1 by JG Colebatch 2006")
    End Sub
End Class
